# -*- coding: utf-8 -*-
#CURRENT VERSION NO : 3.0.0
from flask import Flask, jsonify , send_file
from flask import request
import logging
import mysql.connector
import json
import cgi
import datetime as newdt
from dateutil.relativedelta import relativedelta
import pandas as pd
import numpy as np
from pandas.io.json import json_normalize
import pdb
from io import BytesIO
from datetime import timedelta
import time
from datetime import datetime
import requests
import urllib
import sys
from flask import abort
import smtplib, ssl
from smtplib import SMTP
import schedule
from fluent import sender
from fluent import event
from multiprocessing import Pool

import requests, json
from flask import request, jsonify
import xml.etree.ElementTree as ET

import jwt 
from functools import wraps


try:
    from flask_cors import CORS  # The typical way to import flask-cors
except ImportError:
    # Path hack allows examples to be run without installation.
    import os
    parentdir = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
    os.sys.path.insert(0, parentdir)

    from flask_cors import CORS


app = Flask(__name__)
cors = CORS(app)


global LOGAPPNAME
LOGAPPNAME="SSO"

##########################################################################################################################################
##########################################################################################################################################
DBKEY = "PROD"
##########################################################################################################################################
##########################################################################################################################################



@app.route('/Hello')
def Hello():
    ApplicationErrorLog('INFO','SSO','Hello','',LOGAPPNAME)
    return "kak & Vinoth"


def ApplicationErrorLog(serrortype,sprogram,sfnname,smsg,sAppicationName):
	try:
		if(DBKEY == "PROD"):
			sender.setup(sAppicationName, host='192.168.204.19', port=24224)
			event.Event('PROD', {
			'error_Type': serrortype,
			'program': sprogram,
			'function name':  sfnname,
			'error message': smsg
			})
		else:
			sender.setup(sAppicationName, host='192.168.204.19', port=24224)
			event.Event('DEVL', {
			'error_Type': serrortype,
			'program': sprogram,
			'function name': sfnname,
			'error message': smsg
			})
	except :
		#raise werkzeug.exceptions.HTTPException("Error: %s" % str("ERROR") ) 
		errmsg = str(sys.exc_info()[1]) + ' Line: ' + str(sys.exc_info()[2].tb_lineno)
		print(errmsg)
		raise    



#Error Log for fluent
@app.route('/apiApplicationErrorLog', methods=['GET', 'POST'])
def apiApplicationErrorLog():

	
	try:
	
		req_data = request.get_json() 
		serrortype = req_data['serrortype']
		sprogram = req_data['sprogram']
		sfnname = req_data['sfnname']
		smsg = req_data['smsg']
		sAppicationName = req_data['sAppicationName']
		
		if(DBKEY == "PROD"):
			sender.setup(sAppicationName, host='192.168.204.19', port=24224)
			event.Event('PROD', {
			'error_Type': serrortype,
			'program': sprogram,
			'function name':  sfnname,
			'error message': smsg
			})
			return "PROD"
		else:
			sender.setup(sAppicationName, host='192.168.204.19', port=24224)
			event.Event('DEVL', {
			'error_Type': serrortype,
			'program': sprogram,
			'function name': sfnname,
			'error message': smsg
			})
			return "DEVL"
	except :
		#raise werkzeug.exceptions.HTTPException("Error: %s" % str("ERROR") ) 
		errmsg = str(sys.exc_info()[1]) + ' Line: ' + str(sys.exc_info()[2].tb_lineno)
		print(errmsg)
		raise    
		return errmsg        
        
if __name__=='__main__':
        _pool = Pool(processes=4)
        try:
                if (DBKEY == "PROD"):
                    app.run(host='0.0.0.0', port = 5015, debug = True)
                else:
                    app.run(host='0.0.0.0', port = 9012, debug = True) 					
					
        except KeyboardInterrupt:
                _pool.close()
                _pool.join()

 


# if (DBKEY == "PROD"):
    # app.run(host='0.0.0.0', port = 5015, debug = True)
# else:
    # app.run(host='0.0.0.0', port = 9012, debug = True)

	